/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KategoryPegawai;
import com.portofolio.entity.vo.KategoryPegawaiId;

@Lazy
@Repository
public interface KategoryPegawaiDao extends CrudRepository<KategoryPegawai, KategoryPegawaiId> {


    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaKategoryPegawai like %:namaKategoryPegawai% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKategoryPegawai") String namaKategoryPegawai, @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.id.kdKategoryPegawai = :kdKategoryPegawai")
    Map<String, Object> findByKdKategoryPegawai(@Param("kdProfile") Integer kdProfile, @Param("kdKategoryPegawai") String kdKategoryPegawai,@Param("statusEnabled") boolean statusEnabled);
       
    
    String QListAll ="select new map(model.id.kdKategoryPegawai as kdKategoryPegawai,model.id.kdProfile as kdProfile "
            + ", model.namaKategoryPegawai as namaKategoryPegawai " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.noUrut as noUrut " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from KategoryPegawai model "
            + " left join model.id id "
            + "where id.kdProfile=:kdProfile "
            + "and model.statusEnabled =:statusEnabled "; 

}
